#! /usr/bin/env python
"""
--------------------------------------------------------------------------------

Copyright (C) 2006 Dario Rapisardi <dario@rapisardi.org>
        for the Add/Remove starter dialogs, basic localization and 
	horizontal/vertical selectors.

Copyright (C) 2005 Mike Panchenko <wolabs@gmail.com>
	for the modular interface and modules.

Copyright (C) 2005 Sylvain Fourmanoit <syfou@users.sourceforge.net>
	for the initial Yab code

Copyright (C) 2005 Mike Pirnat <exilejedi@users.sourceforge.net>
	for some ideas, especially configuration-related, see
        configfile.py

Copyright (C) 2004 Lila Community (http://lila-theme.uni.cc/)
        for ALL the included iconic artwork
        
Released under the GPL, version 2. Except the artwork, which is released
pursuant to the restrictions imposed by their authors.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies of the Software and its documentation and acknowledgment shall be
given in the documentation and software packages that this Software was
used.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.   

--------------------------------------------------------------------------------
This was built on python 2.4.0 final, on a linux 2.6.10 glibc 2.3.4
x86 machine. Just run this script from its final location on you disk to
start the desklet. See README for details.

*** DO NOT edit this file for changing the configuration; edit instead
`config.txt' in this directory ***

--------------------------------------------------------------------------------
"""

#-------------------------------------------------------------------------------
import adesklets
#from time import time,sleep,strftime
import time
from os.path import dirname, join
from os import getenv, spawnlp, P_NOWAIT,system

from glob import glob
import os
import string
import re

import pygtk
pygtk.require('2.0')
import gtk
import gobject

# Where the .desktop file are located
MENUDIR="/usr/share/applications"

# Size of the icons
ICON_SIZE=32
# The default icon to use
DEFAULT_ICON="/usr/share/icons/gnome/32x32/stock/document/stock_new.png"

#-------------------------------------------------------------------------------
class Config(adesklets.ConfigFile):
    """

#================================================================================
#    This is the configuration file for the adesklets' desklet `Modubar'.
#
#    You may specify here, for each Modubar instance you use,
#    what icons should be loaded (stored under `icons/' by default,
#    but absolute path names are also valid), what commands they should trigger,
#    what the captions should be, what font to use, how generating effects,
#    etc.
#
#    See `config.txt.minimal' in this directory for the configuration
#    of the completely static (all effects turned off) version of the
#    default bar with some explanations.
#
#    There is no real need for a long explanation here, since
#    a lot of Modubar/Yab configuration parameters are self explanatory.
#    Let us just mention here some specific, less obvious elements:
#
#    - colors are expressed as packed RGB hexadecimal on 24 bits
#    (1 unsigned byte per channel), as you can use within HTML documents
#    for instance: '000000' is pure black, while 'FFFFFF' is pure white.
#
#    - similarily, opacities are given as unsigned one byte decimal
#    integer value (hence in [0, 255])
#
#    - gradient_angle is given in degree, not radians, with 0 degrees being
#    vertical from top to bottom and going clockwise from there.
#    
#    - all parameters expressing times are in seconds. On most systems,
#    resulting timing of less than 10 milliseconds are not reliable and
#    should be avoided.
#    
#    - many parameters can be set to None, zero or similar values, resulting
#    in a more frugal, less dynamic desklet - see `config.txt.minimal' for
#    a more complete exemplification of this.
#
#    - the 'click_effect' parameter, if not set to None, is an imlib2
#    dynamic filter expression that will get applied to the icon you just
#    clicked on for 'click_effect_duration' seconds before being discarded.
#    See your imlib2 documentation for details.
#
#    - the 'icon_maximize_threshold' specifies at what fraction of maximal
#    size the icon under the pointer should be displayed as completly
#    maximized (set to 90% by default). It gives a way to define a 'hot zone'
#    around the icon center's x coordinate in which the pointer can move
#    and the icon stay stuck on its maximum size anyway. Setting this
#    to 0 would make an icon being maximized as soon as the pointer
#    get over it, and setting it to 1 to never get 'pinned' on maximum
#    size as long as the pointer does not reach its very center
#    (thus being smoothly resized from the minimal to the maximal size).
#
#    - all configuration parameters are handled the 'pythonic way', meaning
#    that as few checkups as possible are performed, invalid entries leading
#    to runtime exceptions being raised. For instance, building a bar
#    longer than its screen width will raise a 'did not resize window' error.
#
#    So, whenever you run into trouble configuring a modubar instance, you should:
#
#    	* Kill all adesklets instances running:
#
#    		killall -9 adesklets
#
#    	* Restart the troublemaker from the console using
#        (XXX being its ID number):
#    
#    		ADESKLETS_ID=XXX python modubar.py	
#
#        * Look at the error output to figure things out.
#
#    Finally, please note that destroying this config file while no modubar instances
#    are running will force its repopulation with valid default
#    entries on yap's desklets restart.
#
#    === Modules Doc ===
#    Modules are configured the same way as icons. To configure two clocks in 
#    positions one and two, do
#    'modules': [('clock',1)('clock',2)]
#    All the colors are configured the same way as the colors for the bar itself.
#
#    === Special note on icons ===
#    
#    Only a few icons are shipped with modubar (five, actually).
#    In case you are wondering, they all come from the Lila theme
#    resources (http://lila-theme.uni.cc/). If you go hunting
#    for more iconographic artwork, http://www.kde-look.org/
#    is also a good start point.
#================================================================================
    """
    cfg_default={'bar_background_1': 'AAAAAA',
                 'bar_background_2': None,
                 'bar_foreground': '000000',
                 'bar_gradient_angle': 0,
                 'bar_height': 32,
                 'bar_opacity_1': 100,
                 'bar_opacity_2': None,
                 'caption_above': False,
                 'caption_color': 'AAAAAA',
                 'caption_delay': 0.10000000000000001,
                 'caption_fade_in': True,
                 'caption_fade_in_duration': 0.5,
                 'caption_fade_in_steps': 10,
                 'caption_font': 'Vera',
                 'caption_size': 20,
                 'click_effect': 'tint(alpha=100,red=100,green=100,blue=100);',
                 'click_effect_duration': 0.10000000000000001,
                 'icon_max_height': 128,
                 'icon_max_width': 128,
                 'icon_maximize_threshold': 1.0,
                 'icon_min_height': 64,
                 'icon_min_width': 64,
                 'icon_spacing': 5,
                 'icons': [('firefox.png', 'Firefox', 'firefox')],
                 'label_add_starter': {'C': 'Add_Starter', 'es_ES': 'Agregar_Lanzador'},
		 'label_configure': {'C': 'Configure', 'es_ES': 'Configurar'},
		 'orientation': 'horizontal',
		 'label_remove_starter': {'C': 'Remove_Starter', 'es_ES': 'Quitar_Lanzador'},
		 'label_change_orientation': {'C': 'Rotate', 'es_ES': 'Rotar'},
                 #Modular Properties Start Here 
                 'mod_background_1': 'AAAAAA',
                 'mod_background_2': None,
                 'mod_clock_font': 'Vera',
                 'mod_clock_size': 16,
                 'mod_font_color': '000000',
                 'mod_font_opacity': 'FF', #Hex!!
                 'mod_foreground_1': '000000',
                 'mod_foreground_2': None, #adds a 3d effect. try 000000 to see a good example
                 'mod_opacity_1': 100,
                 'mod_opacity_2': None,
                 'mod_gradient_angle': 0,
                 'module_height': 32,
                 'modules': [('clock', 1)],
                 'modules_on': True}

    def __init__(self,id,filename):
        adesklets.ConfigFile.__init__(self,id,filename)

    def color(self,string):
        return [eval('0x%s' % string[i*2:i*2+2]) for i in range(len(string)/2)]
   

#-------------------------------------------------------------------------------
class Events(adesklets.Events_handler):
    """
    The events driving class
    """
    config = None
    icons = []
    modules = []

#--- desklet high-level initialisation -----------------------------------------
    

    def __init__(self,basedir):
        if len(basedir)==0:
            self.basedir='.'
        else:
            self.basedir=basedir
        self.delay=1
        adesklets.Events_handler.__init__(self)
        
        self._active=1
        self._active_width=0
        self._active_height=0
        self._moved=False

    def __del__(self):
        adesklets.Events_handler.__del__(self)
    
    def ready(self):
      environment = Environment()
      self.lang = environment.getLang()
      self.initialize()
      self.load_icons()
      self.compute_window_size()
      self.set_icon_buffer()
      self.load_caption_font()
      self.resize_window()
      self.display_window()

    def initialize(self):
        # Real initialisation take place here.
        #
        self.config=Config(adesklets.get_id(),
                           join(self.basedir,'config.txt'))

    def add_starter(self, name, icon, executable):
        adesklets.context_set_image(adesklets.load_image(icon))

        self.icons.append((name, executable,
                             adesklets.context_get_image(),
                             adesklets.image_get_width(),
                             adesklets.image_get_height()))

    def del_starter(self, executable):
        i = 0
        for exe in self.icons:
	  if exe[1] == executable:
	    self.icons.pop(i)
	  i+=1

    def load_icons(self):
        # Load all the icons, and retrieve size
        #
        for icon, caption, command in self.config['icons']:
            adesklets.context_set_image(
                adesklets.load_image(join(self.basedir,'icons',icon)))
            self.icons.append((caption, command,
                               adesklets.context_get_image(),
                               adesklets.image_get_width(),
                               adesklets.image_get_height()))
        if self.config['modules_on']:
            for module,position in self.config['modules']:
                self.modules.append((module,position))

    def compute_window_size(self):
        # Compute the window size
        #
        mp=len(self.modules)*84
        if self.config['modules_on']:
            mp=len(self.modules)*84
        else:
            mp=0
	    
	self._window_width  = ((self.config['icon_spacing']+ self.config['icon_min_width'])*len(self.icons)+ (self.config['icon_max_width']- self.config['icon_min_width'])+ self.config['icon_spacing'] + mp)
	self._window_height = self.config['icon_max_height']
	if self.config['orientation'] != 'horizontal':
            temp = self._window_width
            self._window_width = self._window_height
	    self._window_height = temp
       
    def set_icon_buffer(self):
        # Set the icon buffer
        #
        self._buffer_icons=adesklets.create_image(self._window_width-(84*len(self.modules)),
                                                 self._window_height)

        if self.config['modules_on']:
            self._buffer_modules=adesklets.create_image(84*len(self.modules),self._window_height)

    def load_caption_font(self):
        # Load the caption font (if needed), adjusting
        # the window size appropriately
        #
        if self.config['caption_font']:
            adesklets.context_set_font(
                adesklets.load_font('%s/%s' %
                                    (self.config['caption_font'],
                                     str(self.config['caption_size']))))
            dummy, self._caption_height = adesklets.get_text_size('x')
            self._window_height+=self._caption_height

            # Create the caption buffer
            #
            self._buffer_caption=adesklets.create_image(self._window_width,
                                                        self._caption_height)

            # Compute and save final caption color once and for all
            #
            color_base=self.config.color(self.config['caption_color'])
            self._caption_color = color_base + [255]

            # Prepare the fade-in effect
            #
            if self.config['caption_fade_in']:
                adesklets.start_recording()
                time_step = (float(self.config['caption_fade_in_duration'])/
                             self.config['caption_fade_in_steps'])
                fade_step = int(250/self.config['caption_fade_in_steps'])
                for i in range(self.config['caption_fade_in_steps']):
                    adesklets.time_gate((i+1)*time_step)
                    adesklets.context_set_image('$buffer')
                    adesklets.context_set_color(0,0,0,0)
                    adesklets.image_fill_rectangle('$x',0,
                                                   '$width','$height')
                    adesklets.context_set_color(*(color_base+[fade_step*i+5]))
                    adesklets.text_draw('$x',0,'$text')
                    adesklets.context_set_image(0)
                    adesklets.blend_image_onto_image('$buffer',1,
                                                     '$x',0,'$width','$height',
                                                     '$x','$y','$width','$height')
                self._fadein = adesklets.stop_recording()
                adesklets.play_set_abort_on_events(True)
                
            # Set the 'y' and 'buffer' variables once and for all
            #
            if self.config['caption_above']:
                adesklets.set('y',0)
            else:
                adesklets.set('y',self.config['icon_max_height'])
            adesklets.set('buffer',self._buffer_caption)
        else:
            self._caption_height=0
	if self.config['orientation'] != 'horizontal':
            self._caption_height=0

    def resize_window(self):
        # Resize the window
        #
        adesklets.window_resize(self._window_width,self._window_height)
        adesklets.context_set_image(0)
       
    def display_window(self):
        # Finish setting things up, then display the window
        #
        adesklets.context_set_blend(False)
        adesklets.window_set_transparency(True)
        adesklets.menu_add_separator()
	self.configure_label = self.config['label_configure'][self.lang]
	self.add_starter_label = self.config['label_add_starter'][self.lang]
	self.remove_starter_label = self.config['label_remove_starter'][self.lang]
	self.change_orientation_label = self.config['label_change_orientation'][self.lang]
        adesklets.menu_add_item(self.configure_label)
        adesklets.menu_add_item(self.change_orientation_label)
        adesklets.menu_add_item(self.add_starter_label)
        adesklets.menu_add_item(self.remove_starter_label)
        self._display_icons()
        if self.config['modules_on']:
            self._display_modules()
        adesklets.window_show()
    
    def alarm(self):
        self.block()
        if self.config['modules_on']:
            self.display()
        self.unblock()
        return self.delay
    
    def display(self):
        self._display_modules()   

#--- desklet synchronous events management -------------------------------------
    def background_grab(self, delayed):
        """
        Set up the bar background.
        We choosed to work directly on image #1 because
        the operation is always setting the same pixels,
        so there is no real flickering, just a delay.
        """
        if self.config['bar_height']>0:
            # Compute rectangle dimensions
            #
	    if self.config['orientation'] != 'horizontal':
	        coords=[self.config['icon_max_width']/3, 20, self.config['icon_max_width']/3, self.config['bar_height']*(len(self.icons)+1)*2]
            else:
                coords=[0,(self.config['icon_max_height']-
                           self.config['bar_height'])/2,
                           self._window_width,self.config['bar_height']]
            if self.config['caption_above']:
                coords[1]+=self._caption_height

            # Draw it
            #
            adesklets.context_set_blend(True)
            adesklets.context_set_image(1)
            if self.config['bar_background_1']:
                adesklets.context_set_color(
                    *(self.config.color(self.config['bar_background_1'])+
                      [self.config['bar_opacity_1']]))
                if self.config['bar_background_2']:
                    adesklets.context_set_color_range(
                        adesklets.create_color_range())
                    adesklets.add_color_to_color_range(0)
                    adesklets.context_set_color(
                        *(self.config.color(self.config['bar_background_2'])+
                          [self.config['bar_opacity_2']]))
                    adesklets.add_color_to_color_range(self._window_width)
                    adesklets.image_fill_color_range_rectangle(
                        *(coords+([self.config['bar_gradient_angle']])))
                    adesklets.free_color_range(0)
                else:
                    adesklets.image_fill_rectangle(*coords)
            if self.config['bar_foreground']:
                adesklets.context_set_color(
                    *(self.config.color(self.config['bar_foreground']+'FF')))
                adesklets.image_draw_rectangle(*coords)
                
            adesklets.context_set_blend(False)
        
    def menu_fire(self, delayed, menu_id, item):
	mask = []
        for icon in self.config['icons']:
            mask.append(os.path.basename(icon[2]))
        if item==self.configure_label:
            editor=getenv('EDITOR')
            if editor:
                self._execute('xterm -e %s ' % editor +
                              join(self.basedir,'config.txt'))
        if item == self.add_starter_label:
            selector = ItemSelector(self, mask)

	if item == self.remove_starter_label:
	    selector = ItemSelector(self, mask, True)

	if item == self.change_orientation_label:
	    if self.config['orientation'] == 'horizontal':
	        self.config['orientation'] = 'vertical'
	    else:
	        self.config['orientation'] = 'horizontal'
	    print self.config['orientation']
            self.compute_window_size()
            self.set_icon_buffer()
            self.resize_window()
            self.load_caption_font()


    def button_press(self, delayed, x, y, button):
	if self.config['orientation'] != 'horizontal':
            z = x
	    x = y
	    y = z
        if button==1:
            active, scaling = self._get_active_and_scaling(x)
            if active in range(len(self.icons)):
                if self.config['click_effect']:
                    if self.config['caption_font'] and \
                           self.config['caption_above']:
                        y = self._caption_height
                    else:
                        y = 0
                    adesklets.context_set_image(self.icons[active][2])
                    image=adesklets.clone_image()
                    adesklets.context_set_image(image)
                    adesklets.apply_filter(self.config['click_effect'])
                    adesklets.context_set_image(0)
                    adesklets.blend_image_onto_image(image,1,\
                       0,0,self.icons[active][3],self.icons[active][4],
                       *map(lambda x: x[0]+x[1],
                           zip([0,y,0,0],self._position(active,x))))
                    adesklets.free_image(image)
                    time.sleep(max(self.config['click_effect_duration'],.01))
                    adesklets.context_set_blend(False)
                    self._display_icons(x)
                self._execute(self.icons[active][1])

    def motion_notify(self, delayed, x, y):
	if self.config['orientation'] != 'horizontal':
            z = x
	    x = y
	    y = z
        if not delayed:

            if self.config['icon_max_width']!= \
                   self.config['icon_min_width']:
                self._display_icons(x)

        else:
            self._active, scaling = self._get_active_and_scaling(x)
        self._moved=True

    def leave_notify(self, delayed, x, y):
        self._active=None
        self._display_icons()
        self._display_caption()
        
#--- desklet asynchronous events management ------------------------------------
    def pause(self):
        """
        Overrides the pause method from the base class:
        the caption fading effect is called from here,
        since it has to be asynchonous from events.
        """
        active_old=-1
        while True:
            self.block()
            if self._active!=active_old and \
                   self._active in range(len(self.icons)):
                self._display_caption()
            active_old=self._active
            self.unblock()
            
            if self.config['caption_delay']!=0:
                time_initial=time.time()
                while self._moved or (time.time()-time_initial <
                                      max(self.config['caption_delay'],.1)):
                    self.block()
                    if self._moved:
                        time_initial=time.time()
                        self._moved=False
                    self.unblock()
                    time.sleep(max((max(self.config['caption_delay'],.1)-
                               (time.time()-time_initial)),.01))
            else:
                while not self._moved:
                    time.sleep(1)
                self._moved=False
                
#--- desklets drawing utility functions ----------------------------------------
    def _display_icons(self, x=0):
        """
        Note: this routine will only make change to the icons
        part of final image, stored as self._buffer.
        Changing caption is the job of _display_caption, that
        does the job right onto the foreground image
        """
        # Sweep the buffer image
        #
        adesklets.context_set_image(self._buffer_icons)
        adesklets.context_set_color(0,0,0,0)
        adesklets.set('w',self._window_width-(84*len(self.modules)))
        adesklets.image_fill_rectangle(0,0,'$w', self._window_height)
        #XXXadesklets.image_fill_rectangle(0,0,'$w', self.config['icon_max_height'])
        
        # Then reload the icons onto it one by one
        #
        for rank in range(len(self.icons)):
            adesklets.blend_image_onto_image(self.icons[rank][2],1,
                                             0,0,
                                             self.icons[rank][3],
                                             self.icons[rank][4],
                                             *self._position(rank,x))

        # Copy this new image on the foreground
        #
        if self.config['caption_font'] and self.config['caption_above']:
            y = self._caption_height
        else:
            y = 0
        adesklets.context_set_image(0)
        adesklets.blend_image_onto_image(self._buffer_icons,1,
                                         0, 0,
                                         '$w',
                                         self._window_height,
                                         0, y,
                                         '$w',
                                         self._window_height)
        #XXXadesklets.blend_image_onto_image(self._buffer_icons,1,
        #XXX                                 0, 0,
        #XXX                                 '$w',
        #XXX                                 self.config['icon_max_height'],
        #XXX                                 0, y,
        #XXX                                 '$w',
        #XXX                                 self.config['icon_max_height'])

    def _display_caption(self):
        if self.config['caption_font']:
            # Sweep buffer caption clean
            #
            adesklets.context_set_image(self._buffer_caption)
            adesklets.context_set_font(adesklets.load_font('%s/%s' % (self.config['caption_font'], self.config['caption_size'])))
            adesklets.context_set_color(0,0,0,0)
            adesklets.image_fill_rectangle(0,0,
                                           self._window_width,
                                           self._caption_height)
            
            if self._active in range(len(self.icons)) and \
                   len(self.icons[self._active][0])>0:
                # Compute final text position
                #
                
                width, height = adesklets.get_text_size(
                    self.icons[self._active][0])
                pos = self._position(self._active, -1, False)
                x = (pos[0]+pos[2]/2)-width/2
                if x+width>self._window_width: x=self._window_width-x
                if x<0: x=0
                
                # If turned on, performs the caption fade-in
                #
                if self.config['caption_fade_in']:
                    # Sweep window buffer space
                    #
                    adesklets.context_set_image(0)
                    adesklets.blend_image_onto_image(self._buffer_caption,1,
                                                     0,0,
                                                     self._window_width,
                                                     self._caption_height,
                                                     0,adesklets.echo('$y'),
                                                     self._window_width,
                                                     self._caption_height)
                    
                    # Set variables and execute the fade in
                    #
                    adesklets.set('text',self.icons[self._active][0])
                    adesklets.set('x',x)
                    adesklets.set('width',width)
                    adesklets.set('height',height) 
                    adesklets.play(*self._fadein)
                    
                # Force final result, regardless the previous state
                #
                adesklets.context_set_image(self._buffer_caption)
                adesklets.context_set_color(*self._caption_color)
                adesklets.text_draw(x,0,self.icons[self._active][0])
            
            # Render final result on caption buffer
            #
            adesklets.context_set_image(0)    
            adesklets.blend_image_onto_image(self._buffer_caption,1,
                                             0,0,
                                             self._window_width,
                                             self._caption_height,
                                             0,adesklets.echo('$y'),
                                             self._window_width,
                                             self._caption_height)
                
        
    def _position(self, rank, x, compute_active=True):
        """
        Compute the icon final coordinates and size
        """

        # First, compute the active icon rank, scaling and dimensions
        # the 'rank==0' clause is only a performance tuning:
        # since _position is usually called for a sequence of icons
        # (see _display_icons), it is usefull not to recompute
        # these parameters for every icon.
        #
        # Yes, I know, this should be a generator; the thing is it is
        # also called from time to time (only once) from _display_caption
        #
        if rank==0:
                active, scaling = self._get_active_and_scaling(x)
                active_width = int(scaling * self.config['icon_max_width'] +
                                   (1-scaling) * self.config['icon_min_width'])
                active_height = int(scaling * self.config['icon_max_height'] +
                                    (1-scaling) * self.config['icon_min_height'])
                if compute_active:
                    self._active, self._active_width, self._active_height = \
                                  (active, active_width, active_height)
        else:
            active, active_width, active_height = \
                    (self._active, self._active_width, self._active_height)

        # Override previous variable load for 
        if not compute_active:
            active, active_width, active_height = (-1,0,0)

        x=(self.config['icon_spacing']+
             (self.config['icon_max_width']-self.config['icon_min_width'])/2 +
             (self.config['icon_spacing']+self.config['icon_min_width'])*rank)
        y=(self.config['icon_max_height']-self.config['icon_min_height'])/2
        if active in range(len(self.icons)):
            if rank>active:
                x+=(active_width-self.config['icon_min_width'])/2
            else:
                if rank<=active:
                    x-=(active_width-self.config['icon_min_width'])/2
                if rank==active:
                  y-=(active_height-self.config['icon_min_width'])/2  

	if self.config['orientation'] != 'horizontal':
	    z = x
	    x = y
	    y = z
	if rank!=active:
            return (x, y,
                    self.config['icon_min_width'],
                    self.config['icon_min_height'])
        else:
            return (x, y,
                    active_width, active_height)
            
    def _get_active_and_scaling(self,x):
        """
        Compute what icon the mouse is over, as well as the scaling factor
        """
        scaling=1-2*abs((((x-self.config['icon_spacing']-
                           ((self.config['icon_max_width']-
                             self.config['icon_min_width'])/2))%
                          (self.config['icon_min_width']+
                           self.config['icon_spacing']))-
                         ((self.config['icon_min_width']+
                           self.config['icon_spacing'])/2))/
                        float(self.config['icon_min_width']+
                              self.config['icon_spacing']))
        if scaling>=self.config['icon_maximize_threshold']: scaling=1
        return ((x-self.config['icon_spacing']-
                 ((self.config['icon_max_width']-
                   self.config['icon_min_width'])/2))/
                (self.config['icon_min_width']+self.config['icon_spacing']),
                scaling)

    def _execute(self,command):
        spawnlp(P_NOWAIT, command.split()[0], *command.split())

    def _display_module(self, module, position, rootimage):

        if module=="clock": #Determine the module.
            #Draw the initial window for the module. Copy this code until the End of Window comment.
            lcoord=[4,4,80,(self.config['module_height']-8)]
            limg=adesklets.create_image(84,self.config['module_height'])
            adesklets.context_set_image(limg)
            if self.config['mod_background_1']:
                adesklets.context_set_color(
                    *(self.config.color(self.config['mod_background_1'])+
                      [self.config['mod_opacity_1']]))
                if self.config['mod_background_2']:
                    adesklets.context_set_color_range(
                        adesklets.create_color_range())
                    adesklets.add_color_to_color_range(0)
                    adesklets.context_set_color(
                        *(self.config.color(self.config['mod_background_2'])+
                          [self.config['mod_opacity_2']]))
                    adesklets.add_color_to_color_range(self._window_width)
                    adesklets.image_fill_color_range_rectangle(
                        *(lcoord+[self.config['mod_gradient_angle']]))
                    adesklets.free_color_range(0)
                else:
                    adesklets.image_fill_rectangle(*lcoord)
            if self.config['mod_foreground_1'] and not self.config['mod_foreground_2']:
                adesklets.context_set_color(
                    *(self.config.color(self.config['mod_foreground_1']+'FF')))
                adesklets.image_draw_rectangle(*lcoord)
            if self.config['mod_foreground_1'] and self.config['mod_foreground_2']:
                adesklets.context_set_color(
                    *(self.config.color(self.config['mod_foreground_1']+'FF')))
                adesklets.image_draw_line(lcoord[0],lcoord[1],lcoord[2]+4,lcoord[1],'n')
                adesklets.image_draw_line(lcoord[0],lcoord[1],lcoord[0],lcoord[3]+4,'n')
                adesklets.context_set_color(
                    *(self.config.color(self.config['mod_foreground_2']+'FF')))
                adesklets.image_draw_line(lcoord[0],lcoord[3]+4,lcoord[2]+4,lcoord[3]+4,'n')
                adesklets.image_draw_line(lcoord[2]+3,lcoord[1],lcoord[2]+3,lcoord[3]+4,'n')
            #End of Window


            #The Modules Proprietary Code Starts            
            cur_time = self._get_current_time()
            adesklets.context_set_font(
            adesklets.load_font('%s/%s' % (self.config['mod_clock_font'], self.config['mod_clock_size'])))
            w,h=adesklets.get_text_size(cur_time)
            y=(self.config['module_height'])/2-(h/2)
            x=(84/2)-(w/2)
            adesklets.context_set_color(*(self.config.color(self.config['mod_font_color']+self.config['mod_font_opacity'])))
            adesklets.text_draw(x,y,cur_time)
            #End of proprietary code


            #Render module onto _buffer_modules, then clear the image used to draw the module.
            #This code until the End Render comment needs to go at the bottom of your module
            adesklets.context_set_image(rootimage)
            adesklets.blend_image_onto_image (limg,1,
                                              0,
                                              0,
                                              84,
                                              self.config['module_height'],
                                              84*(position-1),
                                              0,
                                              84,
                                              self.config['module_height'])
            adesklets.free_image(limg)
            #End Render




    def _display_modules(self):
        adesklets.context_set_image(self._buffer_modules)

        for mod,pos in self.config['modules']:
            self._display_module(mod,pos,self._buffer_modules)
        yplus=0
        if self.config['caption_above']==True:
            yplus=self._caption_height
        adesklets.context_set_image(0)
        adesklets.blend_image_onto_image (self._buffer_modules,1,
                                              0,
                                              0,
                                              84*len(self.modules),
                                              self.config['module_height'],
                                              self._window_width-(84*len(self.modules))-4,
                                              (self.config['icon_max_height']/2)-(self.config['module_height']/2)+yplus,
                                              84*len(self.modules),
                                              self.config['module_height'])
        
    def _get_current_time(self):
        return time.strftime('%H:%M', time.localtime(time.time()))



class ItemSelector:
  def __init__(self, modubar,mask=[], reverse=False):
    self.reverse = reverse
    self.modubar = modubar
    self.window = gtk.Window()
    self.window.connect("destroy", gtk.main_quit)
    self.window.set_title("Modubar")
    self.window.set_position(gtk.WIN_POS_CENTER_ALWAYS)
    self.window.set_size_request(400, 400)

    scroll = gtk.ScrolledWindow()
    scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    scroll.set_resize_mode(gtk.RESIZE_PARENT)

    tree_view = gtk.TreeView()

    model = gtk.TreeStore(gtk.gdk.Pixbuf, gobject.TYPE_STRING)

    tree_view.set_model(model) 

    box = gtk.VBox()

    menu = Menu()
    items = menu.getItems()

    keys = items.keys()
    self.sort_case_insensitive(keys)
    for item in keys:
      executable = os.path.basename(items[item].getExecutable())
      if not reverse and executable in mask:
        continue
      elif reverse and executable not in mask:
        continue
      pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, ICON_SIZE, ICON_SIZE) 
      pixbuf.fill(0x00000000)
      icon = items[item].getIcon()
      if icon:
        if os.path.exists(icon):
          try:
            pixbuf = gtk.gdk.pixbuf_new_from_file(icon)
            pixbuf = pixbuf.scale_simple(ICON_SIZE, ICON_SIZE, gtk.gdk.INTERP_BILINEAR)
          except:
            items[item].setIcon(DEFAULT_ICON)
	if os.path.exists("/usr/share/pixmaps/%s" % icon):
          try:
            pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/pixmaps/%s" % icon)
            pixbuf = pixbuf.scale_simple(ICON_SIZE, ICON_SIZE, gtk.gdk.INTERP_BILINEAR)
          except:
            items[item].setIcon(DEFAULT_ICON)
      iter = model.insert_before(None, None)
      model.set_value(iter, 1, item)
      model.set_value(iter, 0, pixbuf)

    text_cell = gtk.CellRendererText()
    icon_cell = gtk.CellRendererPixbuf()
    label_column = gtk.TreeViewColumn("Applications List", text_cell, text=1)
    icon_column = gtk.TreeViewColumn("Icons", icon_cell, pixbuf=0)
    tree_view.connect("row_activated", self.__activated, items)
    tree_view.append_column(icon_column)
    tree_view.append_column(label_column)
    tree_view.set_headers_visible(False)
    
    box.pack_start(tree_view, True, True, 3)

    accept_btn = gtk.Button(stock=gtk.STOCK_OK)
    accept_btn.connect("clicked", self.__clicked, tree_view, items)
    scroll.add_with_viewport(box)

    outer_box = gtk.VBox()
    outer_box.pack_start(scroll, True, True, 0)
    outer_box.pack_end(accept_btn, False, False, 5)
    self.window.add(outer_box)
    self.window.show_all()

    gtk.main()

  def sort_case_insensitive(self, listobj):
    memodict = {}
    def compare(a,b):
      aval = memodict.get(a)
      if aval is None: aval = memodict.setdefault(a, a.upper())
      bval = memodict.get(b)
      if bval is None: bval = memodict.setdefault(b, b.upper())
      return cmp(aval, bval)
    listobj.sort(compare)

  def __activated(self, object, a, b, items):
    tree_model, tree_iter = object.get_selection().get_selected()
    key = tree_model.get_value(tree_iter, 1)
    name, icon, executable = items[key].getName(), items[key].getIcon(), items[key].getExecutable()
    if not self.reverse:
      self.__add_starter(name, icon, executable)
    else:
      self.__del_starter(name, icon, executable)

  def __clicked(self, object, tree_view, items):
    tree_model, tree_iter = tree_view.get_selection().get_selected()
    key = tree_model.get_value(tree_iter, 1)
    name, icon, executable = items[key].getName(), items[key].getIcon(), items[key].getExecutable()
    if not self.reverse:
      self.__add_starter(name, icon, executable)
    else:
      self.__del_starter(name, icon, executable)

  def __add_starter(self, name, icon, executable):
    self.window.destroy()
    gtk.main_quit()
    self.modubar.config['icons'].append((icon,name,executable))
    # Make this to save the config file.
    self.modubar.config['icons'] = self.modubar.config['icons']
    self.modubar.add_starter(name, icon, executable)
    self.modubar.compute_window_size()
    self.modubar.set_icon_buffer()
    self.modubar.load_caption_font()
    self.modubar.resize_window()

  def __del_starter(self, name, icon, executable):
    self.window.destroy()
    gtk.main_quit()
    try:
      self.modubar.config['icons'].remove((icon,name,os.path.basename(executable)))
    except:
      self.modubar.config['icons'].remove((icon,name,executable))
    # Make this to save the config file.
    self.modubar.config['icons'] = self.modubar.config['icons']
    self.modubar.del_starter(executable)
    self.modubar.compute_window_size()
    self.modubar.set_icon_buffer()
    self.modubar.load_caption_font()
    self.modubar.resize_window()

class Menu:
  def __init__(self, dir=MENUDIR):
    # key: package name, value: Item object.
    self.items = {}
    files = glob(MENUDIR + "/*")
    for file in files:
      if os.path.isdir(file):
        self.__parsedir(file)
    self.__parsedir(MENUDIR)
        
  def __parsedir(self, dir):
    files = glob(dir + "/*desktop")
    for file in files:
      parser = DotDesktopParser(file)
      item = parser.getItem()
      if item:
        self.items[item.getName()] = item

  def getItems(self):
    return self.items

class DotDesktopParser:
  def __init__(self, filename):
    self.item = None
    self.config = Environment()
    item_file = OptionFile(filename)
    item_name = item_file.getValueByName("Name", self.config.getLang())
    item_icon = self.getAbsolutePath(item_file.getValueByName("Icon"))
    item_exec = self.cleanCommand(item_file.getValueByName("Exec"))
    if self.checkExistance(item_exec) and item_icon:
      self.item = Item(name = item_name, icon = item_icon, executable = item_exec)

  def checkExistance(self, item):
    if not item:
      return False
    if os.path.isabs(item):
      if os.path.exists((os.path.normpath(item).split()[0])):
        return True
    else:
      dirs = string.split(os.environ['PATH'],":")
      for dir in dirs:
        if os.path.exists("%s/%s" % (dir, item.split()[0])):
          return True

    return False

  def getAbsolutePath(self, icon):
    # No icon at all, use default one
    if not icon:
      return DEFAULT_ICON
      
    # It's already absolute
    if os.path.isabs(icon):
      return icon

    # Look fo it:
    icons_dirs = [ "/usr/share/pixmaps" ]

    for icon_dir in icons_dirs:
      files = glob(icon_dir + "/*")
      for file in files:
        if os.path.isfile(file):
	  dirname, filename = os.path.dirname(file), os.path.basename(file)
	  if filename == icon:
	    return file

    return None

  def cleanCommand(self, command):
    if not command:
      return None
    exceptions = ["bug-buddy", "brasero"]
    res = []
    comm = command.split()
    
    if comm[0] in exceptions:
      return comm[0]

    for each in comm:
      if each[:1] != '%':
        res.append(each)

    return string.join(res)
     
  def getItem(self):
    return self.item

class Environment:
  def getLang(self):
    if os.environ.has_key("LANG"):
      return os.environ['LANG'][:5]
    else:
      return "C"

class Item:
  def __init__(self, name=None, icon=None, executable=None):
    self.name = name
    self.icon = icon
    self.executable = executable

  def getName(self):
    return self.name

  def getIcon(self):
    return self.icon

  def setIcon(self, icon):
    self.icon = icon

  def getExecutable(self):
    return self.executable


class OptionFile:
  def __init__(self, filename):
    self.filename = filename
    self.options = {}

    self.parse()

  def parse(self):
    try:
      fd_index = open(self.filename,"r")
    except IOError:
      print "Can't open file %s, check permissions" % self.filename
      return
    for line in fd_index.readlines():
      if line[:1] == "[" or line[:1] == "#" or line[:1] == " " or line[:1] == "\n":
        continue
      exec_args = string.split(line,"=")
      key = exec_args[0]
      exec_args.remove(exec_args[0])
      value = string.join(exec_args)
      self.options[string.strip(key)] = string.strip(value)
    fd_index.close()

  def getValueByName(self, name, lang=None):
    if lang and lang != "C":
      # search for the literal language
      search_name=("%s[%s]" % (name, lang[:5]))
      if self.options.has_key(search_name):
        return self.options[search_name]

      # maybe a general language?
      for key in self.options.keys():
        r = re.compile('^%s\[%s.*\]' % (name, lang[:2]))
        if r.search(key):
          return self.options[key]

    # No lang at all (English actually)
    if self.options.has_key(name):
      return self.options[name]

    # Looks like the option doesn't exist.
    return None


#-------------------------------------------------------------------------------
# Now, let's start everything
#
if hasattr(adesklets,'version_check'):
    Events(dirname(__file__)).pause()
else:
    raise RuntimeError, 'You need adesklets >= 0.3.1. See README.'

